4 USAGE='<fetch-options> <repository> <refspec>...'
7 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
23 while case "$#" in 0) break ;; esac
26 -a|--a|--ap|--app|--appe|--appen|--append)
29 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
30 --upload-pa|--upload-pac|--upload-pack)
35 -f|--f|--fo|--for|--forc|--force)
38 -t|--t|--ta|--tag|--tags)
41 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
44 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
45 --update-he|--update-hea|--update-head|--update-head-|\
46 --update-head-o|--update-head-ok)
52 -k|--k|--ke|--kee|--keep)
56 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
70 test -f "$GIT_DIR/branches/origin" ||
71 test -f "$GIT_DIR/remotes/origin" ||
72 die "Where do you want to fetch from today?"
77 remote=$(get_remote_url "$@")
80 rsync_slurped_objects=
82 rloga="$rloga $remote_nick"
83 test "$remote_nick" = "$remote" || rloga="$rloga $remote"
85 if test "" = "$append"
87 : >"$GIT_DIR/FETCH_HEAD"
90 append_fetch_head () {
97 t) not_for_merge_='not-for-merge' ;;
98 '') not_for_merge_= ;;
101 # remote-nick is the URL given on the command line (or a shorthand)
102 # remote-name is the $GIT_DIR relative refs/ path we computed
105 # the $note_ variable will be fed to git-fmt-merge-msg for further
107 case "$remote_name_" in
111 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
112 note_="branch '$note_' of " ;;
114 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
115 note_="tag '$note_' of " ;;
117 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
118 note_="remote branch '$note_' of " ;;
120 note_="$remote_name of " ;;
122 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
124 note_="$note_$remote_"
126 # 2.6.11-tree tag would not be happy to be fed to resolve.
127 if git-cat-file commit "$head_" >/dev/null 2>&1
129 headc_=$(git-rev-parse --verify "$head_^0") || exit
130 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
131 [ "$verbose" ] && echo >&2 "* committish: $head_"
132 [ "$verbose" ] && echo >&2 " $note_"
134 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
135 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
136 [ "$verbose" ] && echo >&2 " $note_"
138 if test "$local_name_" != ""
140 # We are storing the head locally. Make sure that it is
141 # a fast forward (aka "reverse push").
142 fast_forward_local "$local_name_" "$head_" "$note_"
146 fast_forward_local () {
147 mkdir -p "$(dirname "$GIT_DIR/$1")"
150 # Tags need not be pointing at commits so there
151 # is no way to guarantee "fast-forward" anyway.
152 if test -f "$GIT_DIR/$1"
154 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
156 [ "$verbose" ] && echo >&2 "* $1: same as $3"
158 echo >&2 "* $1: updating with $3"
159 git-update-ref -m "$rloga: updating tag" "$1" "$2"
162 echo >&2 "* $1: storing $3"
163 git-update-ref -m "$rloga: storing tag" "$1" "$2"
167 refs/heads/* | refs/remotes/*)
168 # $1 is the ref being updated.
169 # $2 is the new value for the ref.
170 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
173 # Require fast-forward.
174 mb=$(git-merge-base "$local" "$2") &&
177 if test -n "$verbose"
179 echo >&2 "* $1: same as $3"
183 echo >&2 "* $1: fast forward to $3"
184 echo >&2 " from $local to $2"
185 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
191 echo >&2 "* $1: does not fast forward to $3;"
192 case ",$force,$single_force," in
194 echo >&2 " forcing update."
195 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
198 echo >&2 " not updating."
204 echo >&2 "* $1: storing $3"
205 git-update-ref -m "$rloga: storing head" "$1" "$2"
211 case "$update_head_ok" in
213 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
217 # If --tags (and later --heads or --all) is specified, then we are
218 # not talking about defaults stored in Pull: line of remotes or
219 # branches file, and just fetch those and refspecs explicitly given.
220 # Otherwise we do what we always did.
222 reflist=$(get_remote_refs_for_fetch "$@")
226 git-ls-remote $upload_pack --tags "$remote" |
232 if git-check-ref-format "$name"
234 echo ".${name}:${name}"
236 echo >&2 "warning: tag ${name} ignored"
241 # remote URL plus explicit refspecs; we need to merge them.
242 reflist="$reflist$LF$taglist"
244 # No explicit refspecs; fetch tags only.
257 # These are relative path from $GIT_DIR, typically starting at refs/
259 if expr "z$ref" : 'z\.' >/dev/null
262 ref=$(expr "z$ref" : 'z\.\(.*\)')
266 if expr "z$ref" : 'z+' >/dev/null
269 ref=$(expr "z$ref" : 'z+\(.*\)')
273 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
274 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
276 rref="$rref$LF$remote_name"
278 # There are transports that can fetch only one head at a time...
280 http://* | https://*)
281 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
286 head="ref: $remote_name"
287 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
289 remote_name_quoted=$(@@PERL@@ -e '
292 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
295 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
296 depth=$( expr \( $depth + 1 \) )
298 expr "z$head" : "z$_x40\$" >/dev/null ||
299 die "Failed to fetch $remote_name from $remote"
300 echo >&2 Fetching "$remote_name from $remote" using http
301 git-http-fetch -v -a "$head" "$remote/" || exit
304 TMP_HEAD="$GIT_DIR/TMP_HEAD"
305 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
306 head=$(git-rev-parse --verify TMP_HEAD)
308 test "$rsync_slurped_objects" || {
309 rsync -av --ignore-existing --exclude info \
310 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
312 # Look at objects/info/alternates for rsync -- http will
313 # support it natively and git native ones will do it on
314 # the remote end. Not having that file is not a crime.
315 rsync -q "$remote/objects/info/alternates" \
316 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
317 rm -f "$GIT_DIR/TMP_ALT"
318 if test -f "$GIT_DIR/TMP_ALT"
320 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
323 case "$alt" in 'bad alternate: '*) die "$alt";; esac
324 echo >&2 "Getting alternate: $alt"
325 rsync -av --ignore-existing --exclude info \
326 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
328 rm -f "$GIT_DIR/TMP_ALT"
330 rsync_slurped_objects=t
334 # We will do git native transport with just one call later.
338 append_fetch_head "$head" "$remote" \
339 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
344 http://* | https://* | rsync://* )
345 ;; # we are already done.
347 ( : subshell because we muck with IFS
350 git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
352 while read sha1 remote_name
356 echo >&2 "Fetch failure: $remote"
384 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
385 append_fetch_head "$sha1" "$remote" \
386 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
393 fetch_main "$reflist"
395 # automated tag following
396 case "$no_tags$tags" in
400 # effective only when we are following remote branch
401 # using local tracking branch.
403 git-ls-remote $upload_pack --tags "$remote" |
404 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
407 test -f "$GIT_DIR/$name" && continue
408 git-check-ref-format "$name" || {
409 echo >&2 "warning: tag ${name} ignored"
412 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
413 echo >&2 "Auto-following $name"
414 echo ".${name}:${name}"
420 fetch_main "$taglist" ;;
424 # If the original head was empty (i.e. no "master" yet), or
425 # if we were told not to worry, we do not have to check.
426 case ",$update_head_ok,$orig_head," in
430 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
431 if test "$curr_head" != "$orig_head"
434 -m "$rloga: Undoing incorrectly fetched HEAD." \
436 die "Cannot fetch into the current branch."